<?php

// Read in the cacti database configuration
include_once('../../include' . '/config.php');

// Create Connection to the Cacti database
$link = mysql_connect($database_hostname, $database_username, $database_password);
mysql_select_db($database_default);

// nmidCreatePDF functions ( get Report list, add graphs to report ... )
include_once('nmidCreatePDF_functions.php');

// graph functions ( getGraph )
include_once('graph_functions.php');

// thold functions
include_once('thold_functions.php');

// weathermap functions
include_once('weathermap_functions.php');

// basic functions ( get down hosts ... )
include_once('basic_functions.php');

// user management ( getChallenge, authUser ... )
include_once('user_functions.php');

// smokeping functions ( get config, graph ... )
include_once('smokeping_functions.php');

include_once('Zend/Soap/AutoDiscover.php');
include_once('Zend/Soap/Server.php');
//include_once('Zend/Soap/Wsdl.php');


/* FUNCTIONS */

/**
* Retrieve the NagiosPNP UserID
*
* @param string $password
* @return string
*/
function getNagiosPNPUser ( $password )
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
        return readConfigOption('nmid_naguser') ;
    }
    else
    {
        return 'Error: Wrong WebService Password';        
    }
}



/**
* Retrieve the NagiosPNP Password
*
* @param string $password
* @return string
*/
function getNagiosPNPPassword ( $password )
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
        return readConfigOption('nmid_nagpwd');
    }
    else
    {
        return 'Error: Wrong WebService Password';        
    }
}

/**
* Nagios PNP Server URL
*
* @param string $password
* @param string $server
* @return string
*/
function getNagiosPNPServerURL( $password, $server )
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
        if ( preg_match("/^nmid_nagserver\d$/", $server ) > 0 )
        {
            return readConfigOption( $server ) . readConfigOption( 'nmid_nagurl' ) ;
        }
        else
        {
            return 'Error: Invalid Server : '.$server;
        }
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}

/**
* Retrieves the CiscoWorks config
*
* @param string $password
* @param string $server
* @return string
*/
function getCiscoWorksConfig( $password )
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
        $ourFileName = "../nmid/ciscoworks_config.txt";
        if ( file_exists($ourFileName) )
        {
            $lines = file($ourFileName);
            $ciscoworksConfig = '';
            foreach ($lines as $line)
            {
                $ciscoworksConfig .= $line;
            }
            return $ciscoworksConfig;
        }
        else {
            return 'Error: CiscoWorks Config does not exist.';
        }
    }
    else
    {
        return 'Error: Wrong WebService Password';        
    }
}


/**
 * Service function getTree
 * 
 * @param string $s_sessionKey
 * @return string
 */
function getTree( $s_sessionKey ) {
	if  ( isSessionActive ( $s_sessionKey )  )
	{
	$i = 0;
	$sql = "select * from graph_tree order by name";
	$result = mysql_query($sql);
	$oldTier = 1;
	$path = '';
	$text = '';
	$isSmokepingEnabled = readPluginStatus('nmidSmokeping') || FALSE;
	while ( $item = mysql_fetch_assoc ( $result ) )
	{
		$path = '';
		$text = $text . $item['name']. "\n";
	//  and graph_tree_items.local_graph_id=0		
$treeSQL = "select
			graph_tree_items.id,
			graph_tree_items.local_graph_id,
			graph_tree_items.title,
			graph_tree_items.order_key as order_key,
			graph_tree_items.host_id as host_id,
			graph_tree_items.host_grouping_type,
			host.description as hostname,
			host.hostname as ipaddress
			from graph_tree_items
			left join host on (host.id=graph_tree_items.host_id)
			where graph_tree_items.graph_tree_id=" . $item['id'] . "
			order by graph_tree_items.order_key";
		$treeResult = mysql_query ( $treeSQL );
		$tierMenu[] = array();
		$tierMenu[0] = $item['name'];
		while ( $subItem = mysql_fetch_assoc ( $treeResult ) )
		{
			$tier = tree_tier( $subItem["order_key"] );

			if ( $subItem['hostname'] ) 
			{
				$tierMenu[$tier] = $subItem['hostname'];	
			} 
			else if ( $subItem['local_graph_id'] > 0 ) {
				$titleSQL = 'SELECT
graph_templates_graph.title_cache as title_cache
FROM (graph_local,graph_templates_graph)
LEFT JOIN graph_templates ON (graph_local.graph_template_id=graph_templates.id)
WHERE graph_local.id=graph_templates_graph.local_graph_id
AND graph_local.id = '.$subItem['local_graph_id'];
				
				$localTitle = getDBValue('title_cache',$titleSQL);
				$tierMenu[$tier] = $subItem['local_graph_id'].'- '.$localTitle;
			}
			else 
			{
				$tierMenu[$tier] = $subItem['title'];
			}
			$path = '';
			for ( $i = 0; $i <= $tier; $i++ ) 
			{
				$path = $path .'/'.  $tierMenu[$i];
			}
			$path = preg_replace("/\/$/","",$path);
			$path = preg_replace("/^\//","",$path);
			if ( $subItem['hostname'] ) {
				$text = $text .$path. "\n";
				$orderKey = preg_replace("/0+$/","",$subItem['order_key']);
				$sql = "select host_id,local_graph_id,rra_id from graph_tree_items where host_id=".$subItem['host_id']." AND graph_tree_id=".$item["id"]." AND order_key like '".$orderKey."___000%';";
				$graphResult = mysql_query($sql);
				while ($row = mysql_fetch_assoc($graphResult)) {
					if ($row['host_id'] > 0)
					{
						$sql = "
							SELECT
							graph_templates_graph.id as id,
							graph_templates_graph.local_graph_id as lgid,
							graph_templates_graph.height as height,
							graph_templates_graph.width as width, 
							graph_templates_graph.title_cache as title_cache,
							graph_templates.name as name,
							graph_local.host_id as host_id
							FROM (graph_local,graph_templates_graph)
							LEFT JOIN graph_templates ON (graph_local.graph_template_id=graph_templates.id)
							WHERE graph_local.id=graph_templates_graph.local_graph_id
							AND host_id = ".$row['host_id'];
						$subResult = mysql_query($sql);
						while ($subRow = mysql_fetch_assoc($subResult))
						{
							$graphTitle = $subRow['title_cache'];
							$graphTitle = preg_replace("/\//","\\", $graphTitle);
							$graphTitle = preg_replace("/".$subItem['hostname']." -/","",$graphTitle);
							$text = $text .$path. '/'. $subRow['lgid'].'- '. $graphTitle ."\n";
						}
						if ( $isSmokepingEnabled )
						{
							$isHostEnabled = getDBValue( 'nwmgmt_settings',"select nwmgmt_settings from host where id=".$row['host_id'] );
							if ( preg_match("/^s1/",$isHostEnabled) == 1 )
							{
								$title = "Smokeping Graph: ".getDBValue( 'description', "select description from host where id=".$row['host_id'] );  
								$text = $text . $path . '/sp'.$row['host_id'].'- '.$title."\n";
							}
						}
					}
					else if ( $row['local_graph_id'] > 0)
					{
						$sql = "
							SELECT
							graph_templates_graph.id as id,
							graph_templates_graph.local_graph_id as lgid,
							graph_templates_graph.height as height,
							graph_templates_graph.width as width,
							graph_templates_graph.title_cache as title_cache,
							graph_templates.name as name,
							graph_local.host_id as host_id
							FROM (graph_local,graph_templates_graph)
							LEFT JOIN graph_templates ON (graph_local.graph_template_id=graph_templates.id)
							WHERE graph_local.id=graph_templates_graph.local_graph_id
							AND graph_templates_graph.local_graph_id  = ".$row['local_graph_id']
						;
						$subResult = mysql_query($sql);
						while ($subRow = mysql_fetch_assoc($subResult))
						{
							$text = $text .$path. '/' .$subRow['lgid'].'-'. $subRow['title_cache'] ."\n";
						}
					}
				}  
			} else {
				$text = $text .$path."\n";
			}
		}
	}
        mysql_free_result($result);
        return $text;
    }
    else
    {
         return array('returnVal' => "Error: Wrong WebService Password");
    }
    return array('returnVal' => "Error: No Data" );
}

// Checks the given password with the web-service password stored in the cacti
// DB
function checkPassword( $password )
{
    $nmid_wspassword = readConfigOption('nmid_wspassword');
    if ($password == $nmid_wspassword)
    {
        return 1;
    }
    return 0;
}

// Checks the given password with the web-service password stored in the cacti
// DB
function readConfigOption( $option )
{
    $query = "select value from settings where name='".$option."'";
    $result = mysql_query($query);
    $config_option = mysql_fetch_assoc($result);
    // Free the result set
    mysql_free_result($result);
    return $config_option['value'];
}

// retrieve one specific value from a table
function getDBValue( $name, $sql ) {
    $result = mysql_query($sql);
    $return = mysql_fetch_assoc($result);
    // Free the result set
    mysql_free_result($result);
    return $return[$name];
}

// validation functions
function isNumber ( $var ) {
    if (ereg("^([0-9]+)$", $var, $matches)) {
        return TRUE;
    }
    else {
        return FALSE;
    }
}

function getTextEscaped ( $var ) {
   return mysql_real_escape_string( $var );
}

function getNumber ( $var ) {
   return intval( $var );
}

// Check Plugin status / support
function readPluginStatus( $plugin ) {
    $query = "select status from plugin_config where directory='".$plugin."'";
    $result = mysql_query($query);
    $plugin_status = mysql_fetch_assoc($result);
    // Free the result set
    mysql_free_result($result);
    return $plugin_status['status'];
}

function tree_tier($order_key, $chars_per_tier = 3) {
        $root_test = str_pad('', $chars_per_tier, '0');

        if (preg_match("/^$root_test/", $order_key)) {
                $tier = 0;
        }else{
                $tier = ceil(strlen(preg_replace("/0+$/",'',$order_key)) / $chars_per_tier);
        }

        return $tier;
}

/* ACTUAL SERVER */

ini_set("soap.wsdl_cache_enabled", "0");

$url = readConfigOption('nmid_wsserver'). 'plugins/nmidWebService/webservice.php' ;

$options = array();
#
if(isset($_REQUEST['wsdl'])) {
    $autodiscover = new Zend_Soap_AutoDiscover();
    //$autodiscover->setOperationBodyStyle(
    //    array('use' => 'literal')
    //);
    // Default is 'style' => 'rpc' and
    // 'transport' => 'http://schemas.xmlsoap.org/soap/http'
    //$autodiscover->setBindingStyle(
    //    array('style' => 'document')
    //);    
    $autodiscover->addFunction('isMobileAccessEnabled');
    $autodiscover->addFunction('getTree');
    $autodiscover->addFunction('authUser');
    $autodiscover->addFunction('isSessionActive');
    $autodiscover->addFunction('getFavourites');
    $autodiscover->addFunction('delGraphFromFavourites');
    $autodiscover->addFunction('addGraphToFavourites');
    $autodiscover->addFunction('isGraphInFavourites');
    $autodiscover->addFunction('getGraph');
    $autodiscover->addFunction('getThold');
    $autodiscover->addFunction('isUserTholdEnabled');
    $autodiscover->addFunction('isWeatherMapEnabled');
    $autodiscover->addFunction('getWeathermapsList');
    $autodiscover->addFunction('getWeathermapImage');
    $autodiscover->addFunction('getDownHosts');
    $autodiscover->addFunction('getReportList');
    $autodiscover->addFunction('addGraphToReport');
    $autodiscover->addFunction('getPluginStatus');
    $autodiscover->addFunction('getSmokePingGraph');
    $autodiscover->addFunction('getSmokePingServerURL');
    $autodiscover->addFunction('getSmokePingUser');
    $autodiscover->addFunction('getSmokePingPassword');
    $autodiscover->addFunction('getSmokePingConfig');
    $autodiscover->handle();
} else {
    // pointing to the current file here
    $server = new Zend_Soap_Server($url.'?wsdl');
    $server->addFunction('isMobileAccessEnabled');
    $server->addFunction('authUser');
    $server->addFunction('isSessionActive');
    $server->addFunction('getFavourites');
    $server->addFunction('delGraphFromFavourites');
    $server->addFunction('addGraphToFavourites');
    $server->addFunction('isGraphInFavourites');
    $server->addFunction('getTree');
    $server->addFunction('getGraph');
    $server->addFunction('getThold');
    $server->addFunction('isUserTholdEnabled');
    $server->addFunction('isWeatherMapEnabled');
    $server->addFunction('getWeathermapsList');
    $server->addFunction('getWeathermapImage');
    $server->addFunction('getDownHosts');
    $server->addFunction('getPluginStatus');
    $server->addFunction('getReportList');
    $server->addFunction('addGraphToReport');
    $server->addFunction('getSmokePingGraph');
    $server->addFunction('getSmokePingServerURL');
    $server->addFunction('getSmokePingUser');
    $server->addFunction('getSmokePingPassword');
    $server->addFunction('getSmokePingConfig');
    $server->handle();
}



// Close the database connection
mysql_close( $link );
?>
